// C Source File
// Created 6/7/2004; 11:06:31 AM

#ifndef _WEAPON_C_
#define _WEAPON_C_

#include "weapon.h"

void doWeaponStuff(Camera *camera, Weapon *this, Point home)
{
	if (this->type == SINGLE) {
		this->location.x += this->momentum.x;
		this->location.y += this->momentum.y;
		this->location.z += this->momentum.z;
	}
	if (this->type == HOMING) {
		if (this->location.x < home.x)
			this->location.x += 2;
		else if (this->location.x > home.x)
			this->location.x -= 2;

		if (this->location.z < home.z)
			this->location.z += 2;
		else if (this->location.z > home.z)
			this->location.z -= 2;

		if (this->location.y < home.y)
			this->location.y += 1;
		else if (this->location.y > home.y)
			this->location.y -= 1;
	}

	this->energy--;

	drawLines(camera, this->location, this->direction, this->objlines, this->numlines, 2);
}

void createPulse(Weapon *this)
{
	this->numlines = 4;
	this->location = newPoint(0, 0, 0);
	this->direction = newAngle(0, 0, 0);
	this->momentum = newPoint(0, 0, -2);
	this->energy = 50;
	this->damage = 8;
	this->type = HOMING;

	this->objlines[0].point[0] = newPoint( -2,  0, -2);
	this->objlines[0].point[1] = newPoint( -2,  0,  2);

	this->objlines[1].point[0] = newPoint( -2,  0,  2);
	this->objlines[1].point[1] = newPoint(  2,  0,  2);

	this->objlines[2].point[0] = newPoint(  2,  0,  2);
	this->objlines[2].point[1] = newPoint(  2,  0, -2);

	this->objlines[3].point[0] = newPoint(  2,  0, -2);
	this->objlines[3].point[1] = newPoint( -2,  0, -2);

}

void createSheildBarrier(Weapon *this)
{
	this->numlines = 2;
	this->location = newPoint(0, 0, 0);
	this->direction = newAngle(0, 0, 0);
	this->momentum = newPoint(10, 0, 0);
	this->energy = 8;
	this->damage = 40;
	this->type = SINGLE;

	this->objlines[0].point[0] = newPoint( -1,  -4, 0);
	this->objlines[0].point[1] = newPoint( -1,   4, 0);

	this->objlines[1].point[0] = newPoint(  1,  -4, 0);
	this->objlines[1].point[1] = newPoint(  1,   4, 0);

}

void createLaser(Weapon *this)
{
	this->numlines = 2;
	this->location = newPoint(0, 0, 0);
	this->direction = newAngle(0, 0, 0);
	this->momentum = newPoint(0, 0, 5);
	this->energy = 30;
	this->damage = 10;
	this->type = SINGLE;

	this->objlines[0].point[0] = newPoint( -1,  0,  0);
	this->objlines[0].point[1] = newPoint( -1,  0,  8);

	this->objlines[1].point[0] = newPoint(  1,  0,  0);
	this->objlines[1].point[1] = newPoint(  1,  0,  8);

}

void createBlast(Weapon *this)
{
	this->numlines = 3;
	this->location = newPoint(0, 0, 0);
	this->direction = newAngle(0, 0, 0);
	this->momentum = newPoint(0, 0, 4);
	this->energy = 20;
	this->damage = 50;
	this->type = SINGLE;

	this->objlines[0].point[0] = newPoint( -3,  0,  0);
	this->objlines[0].point[1] = newPoint(  3,  0,  0);

	this->objlines[1].point[0] = newPoint( -2,  0,  2);
	this->objlines[1].point[1] = newPoint(  2,  0,  2);

	this->objlines[2].point[0] = newPoint( -1,  0,  4);
	this->objlines[2].point[1] = newPoint(  1,  0,  4);

}

#endif
